libstdc++: __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash > Struct Template Reference

libstdc++

__gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash > Struct Template Reference
Extensions » Policy-Based Data Structures » Traits

`#include <types_traits.hpp>`

Inheritance diagram for __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >:
[legend]

## Public Types
typedef std::pair< size_type, size_type > | comp_hash
typedef __rebind_va::const_pointer | const_pointer
typedef __rebind_va::const_reference | const_reference
typedef __rebind_ka::const_pointer | key_const_pointer
typedef __rebind_ka::const_reference | key_const_reference
typedef __rebind_ka::pointer | key_pointer
typedef __rebind_ka::reference | key_reference
typedef Key | key_type
typedef __rebind_ma::const_pointer | mapped_const_pointer
typedef __rebind_ma::const_reference | mapped_const_reference
typedef __rebind_ma::pointer | mapped_pointer
typedef __rebind_ma::reference | mapped_reference
typedef Mapped | mapped_type
typedef __nothrowcopy::indicator | no_throw_indicator
typedef __rebind_va::pointer | pointer
typedef __rebind_va::reference | reference
typedef _Alloc::size_type | size_type
typedef integral_constant< int, Store_Hash > | store_extra
typedef stored_data< value_type, size_type, Store_Hash > | stored_data_type
typedef select_value_type< Key, Mapped >::type | value_type

## Public Attributes
no_throw_indicator | m_no_throw_copies_indicator
store_extra | m_store_extra_indicator

## Detailed Description

template<typename Key, typename Mapped, typename _Alloc, bool Store_Hash>
struct __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >

Traits for abstract types.

Definition at line 154 of file types_traits.hpp.

## Member Typedef Documentation

## ◆ comp_hash

template<typename Key, typename Mapped, typename _Alloc, bool Store_Hash>

typedef std::pair<size_type, size_type> __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::comp_hash

Definition at line 187 of file types_traits.hpp.

## ◆ const_pointer

template<typename Key, typename Mapped, typename _Alloc, bool Store_Hash>

typedef __rebind_va::const_pointer __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::const_pointer

Definition at line 177 of file types_traits.hpp.

## ◆ const_reference

template<typename Key, typename Mapped, typename _Alloc, bool Store_Hash>

typedef __rebind_va::const_reference __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::const_reference

Definition at line 179 of file types_traits.hpp.

## ◆ key_const_pointer

template<typename Key, typename Mapped, typename _Alloc, bool Store_Hash>

typedef __rebind_ka::const_pointer __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::key_const_pointer

Definition at line 184 of file types_traits.hpp.

## ◆ key_const_reference

template<typename Key, typename Mapped, typename _Alloc, bool Store_Hash>

typedef __rebind_ka::const_reference __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::key_const_reference

Definition at line 186 of file types_traits.hpp.

## ◆ key_pointer

template<typename Key, typename Mapped, typename _Alloc, bool Store_Hash>

typedef __rebind_ka::pointer __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::key_pointer

Definition at line 183 of file types_traits.hpp.

## ◆ key_reference

template<typename Key, typename Mapped, typename _Alloc, bool Store_Hash>

typedef __rebind_ka::reference __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::key_reference

Definition at line 185 of file types_traits.hpp.

## ◆ key_type

template<typename Key, typename Mapped, typename _Alloc, bool Store_Hash>

typedef Key __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::key_type

Definition at line 160 of file types_traits.hpp.

## ◆ mapped_const_pointer

template<typename Key, typename Mapped, typename _Alloc, bool Store_Hash>

typedef __rebind_ma::const_pointer __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::mapped_const_pointer

Definition at line 172 of file types_traits.hpp.

## ◆ mapped_const_reference

template<typename Key, typename Mapped, typename _Alloc, bool Store_Hash>

typedef __rebind_ma::const_reference __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::mapped_const_reference

Definition at line 174 of file types_traits.hpp.

## ◆ mapped_pointer

template<typename Key, typename Mapped, typename _Alloc, bool Store_Hash>

typedef __rebind_ma::pointer __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::mapped_pointer

Definition at line 171 of file types_traits.hpp.

## ◆ mapped_reference

template<typename Key, typename Mapped, typename _Alloc, bool Store_Hash>

typedef __rebind_ma::reference __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::mapped_reference

Definition at line 173 of file types_traits.hpp.

## ◆ mapped_type

template<typename Key, typename Mapped, typename _Alloc, bool Store_Hash>

typedef Mapped __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::mapped_type

Definition at line 161 of file types_traits.hpp.

## ◆ no_throw_indicator

template<typename Key, typename Mapped, typename _Alloc, bool Store_Hash>

typedef __nothrowcopy::indicator __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::no_throw_indicator

Definition at line 189 of file types_traits.hpp.

## ◆ pointer

template<typename Key, typename Mapped, typename _Alloc, bool Store_Hash>

typedef __rebind_va::pointer __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::pointer

Definition at line 176 of file types_traits.hpp.

## ◆ reference

template<typename Key, typename Mapped, typename _Alloc, bool Store_Hash>

typedef __rebind_va::reference __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::reference

Definition at line 178 of file types_traits.hpp.

## ◆ size_type

template<typename Key, typename Mapped, typename _Alloc, bool Store_Hash>

typedef _Alloc::size_type __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::size_type

Definition at line 158 of file types_traits.hpp.

## ◆ store_extra

template<typename Key, typename Mapped, typename _Alloc, bool Store_Hash>

typedef integral_constant<int, Store_Hash> __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::store_extra

Definition at line 188 of file types_traits.hpp.

## ◆ stored_data_type

template<typename Key, typename Mapped, typename _Alloc, bool Store_Hash>

typedef stored_data<value_type, size_type, Store_Hash> __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::stored_data_type

Definition at line 181 of file types_traits.hpp.

## ◆ value_type

template<typename Key, typename Mapped, typename _Alloc, bool Store_Hash>

typedef select_value_type<Key,Mapped>::type __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::value_type

Definition at line 159 of file types_traits.hpp.

## Member Data Documentation

## ◆ m_no_throw_copies_indicator

template<typename Key, typename Mapped, typename _Alloc, bool Store_Hash>

no_throw_indicator __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::m_no_throw_copies_indicator

Definition at line 192 of file types_traits.hpp.

## ◆ m_store_extra_indicator

template<typename Key, typename Mapped, typename _Alloc, bool Store_Hash>

store_extra __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::m_store_extra_indicator

Definition at line 191 of file types_traits.hpp.

The documentation for this struct was generated from the following file:

- types_traits.hpp